;
;       This program will input a list of numbers, convert them to
;       numeric form and store them in an array, then it will then
;       SORT the list
;          this program will make several copies of lists and will
;          SORT in subprograms in several different ways 
;       and then will output as follows
;          the list of numbers - removes from the array and
;          converts back to ascii then prints
;          Prints both the sorted and unsorted versions
;
;
CR      EQU     0DH
LF      EQU     0AH
EOL     EQU     'E'
;
        .MODEL   SMALL

;               STACK FOR RETURNS
;
        .STACK 100H
;
;               DATA AREA
;
        .DATA    
;
CRLF    DB      CR,LF,'$'
PTITLE  DB      CR,LF,' EXAMPLE PROGRAM: SORTING A LIST OF NUMBERS',CR,LF,'$'
REQUST  DB      CR,LF,' INPUT A 1-BYTE NUMBER / E TO END ---> $'
HEAD1   DB      CR,LF,'     THE LIST OF NUMBERS $'
NUMBLNE DB      CR,LF,'                         $'
SIZELNE DB      CR,LF,' THERE ARE       NUMBERS IN THE LIST $'
;
SRTLNE  DB      CR,LF,' THE SORTED LIST OF NUMBERS',CR,LF,'$'
INBUFF  DB      4,0,'     '
;   arrays of numbers
NUMBS   DB      127 DUP(0)              ;ARRAY FOR NUMERIC FORM
A1      DB      127 DUP(0)
A2      DB      127 DUP(0)
A3      DB      127 DUP(0)
A4      DB      127 DUP(0)
N       DB      0

; global variable used by atoi and itoa subprograms
SIGN    DB      0
;
;
;
;               CODE: THE MAIN PROGRAM
;
        .CODE
;
;
MAIN    PROC    FAR             ;FAR SO THAT RETURN TO DOS
;
	  .STARTUP      
;               PRINT TITLE
;
        LEA     DX,PTITLE
        CALL    STROUT
;
;               PART I - READ THE DATA VALUES AND CONVERT
;                        TO NUMERIC
;
        MOV     DI,0            ;SUBSCRIPT INTO NUMBS ARRAY
        MOV     N,0         ;COUNT OF THE NUMBERS READ
INPUT_DATA:
        LEA    DX,REQUST        ;READ A NUMBER
        CALL   STROUT
        LEA    DX,INBUFF
        CALL   INPUT
;
        MOV     AL,INBUFF[2]    ;TEST FOR END OF LIST
        CMP     AL,EOL
        JE      PRINTUNSORTED
;
        LEA     BX,INBUFF
        CALL    CONVRTNUM       ;CONVERT TO NUMERIC
;
        MOV     NUMBS[DI],AL    ;STORE IN ARRAY
        INC     DI
        INC     N
;
        JMP     INPUT_DATA
;
;               PART II PRINT OUT THE UNSORTED LIST
;
;  first print out the unsorted list
;  the heading to print is indicated by the parameter in AL
PRINTUNSORTED:
        MOV    AL,0
        LEA    BX,NUMBS
        CALL   PRINTLIST
;
;   next make some copies of the lists to sort
        LEA    SI,NUMBS
        LEA    DI,A1
        MOV    CH,0
        MOV    CL,N
        CALL   COPYLIST
;
        LEA    SI,NUMBS
        LEA    DI,A2
        MOV    CH,0
        MOV    CL,N
        CALL   COPYLIST
;
        LEA    SI,NUMBS
        LEA    DI,A3
        MOV    CH,0
        MOV    CL,N
        CALL   COPYLIST
;
        LEA    SI,NUMBS
        LEA    DI,A4
        MOV    CH,0
        MOV    CL,N
        CALL   COPYLIST

;              
;               PART III SORT THE LIST - CALL SUBPROGRAM
;
;  SIMPLE EXCHANGE SORT
;    sort the list - send in the parameters as follows
;    BX = address of list to sort
;    DL = size of list
      MOV    DL,N
      LEA    BX,A1
      CALL   EXCHANGESORT
;
;
;  SIMPLE BUBBLE SORT
;
        MOV    DL,N
        LEA    BX,A2
        CALL   BUBBLESORT
;
;  SIMPLE INSERTION SORT
;
        MOV    DL,N
        LEA    BX,A3
        CALL   INSERTIONSORT
;
;  RECURSIVE QUICKSORT
;    quickSort (A,left,right)
;      since we use the same array - use BX as above
;      left and right are placed on the stack
;      quickSort (A,0,n-1) is the initial call
;      where n = array size
        LEA    BX,A4
        MOV    AX,0
        PUSH   AX      ;left = 0
        MOV    AH,0
        MOV    AL,N
        DEC    AX
        PUSH   AX      ; right = n-1
        CALL   QUICKSORT               
;
;
;              PART IV PRINT OUT THE SORTED LIST
;   print out the sorted list
;
        MOV   AL,1
        LEA   BX,A1
        CALL  PRINTLIST
;
        MOV   AL,1
        LEA   BX,A2
        CALL  PRINTLIST
;
        MOV   AL,1
        LEA   BX,A3
        CALL  PRINTLIST
;
        MOV   AL,1
        LEA   BX,A4
        CALL  PRINTLIST

;
;   EXIT THE PROGRAM
REBOOT:
        .EXIT
MAIN    ENDP
;
; *************************  SUBPROGRAMS ********************
;
;   --------------- i/o subprograms
STROUT  PROC    NEAR
        MOV     AH,09H
        INT     21H
        RET
STROUT  ENDP
;
INPUT   PROC    NEAR
        MOV     AH,0AH
        INT     21H
        RET
INPUT   ENDP
;
;   ---------------- conversions - ascii to int and int to ascii
;          restricted to 1-byte quantities
; ATOI
CONVRTNUM       PROC    NEAR
;
;       Converts an ascii character string that is all digits (with an
;       optional "-" sign.  The number is to a 1-byte quantity.
;       The converted number is returned in the AL register
;       The BX register holds the base address of the string to be
;       converted.
;
        MOV     SI,2
        MOV     CH,0
        MOV     CL,[BX+1]
        MOV     SIGN,0
;
;       Remember the sign - if any
;       Since the quantity '-' is an immediate the machine wants the
;       operand [BX+SI] to imply the size (byte, word, etc.) but is does
;       not do that.  This the size attribute must be used in this case.
;
        CMP     BYTE PTR [BX+SI],'-'
        JNE     PROCESSDIGITS
        INC     SIGN
        INC     SI
        DEC     CX
;
PROCESSDIGITS:
        MOV     AL,0
        MOV     DL,10
;
CONVLOOP:
        JCXZ    SIGNPROCESS
        MOV     DH,[BX+SI]
        SUB     DH,'0'
;
        MUL     DL
        ADD     AL,DH
;
        INC     SI
        DEC     CX
        JMP     CONVLOOP
;
SIGNPROCESS:
        CMP     SIGN,0
        JE      CONVERTDONE
        NEG     AL
CONVERTDONE:
        RET
CONVRTNUM  ENDP
;
;
; ITOA
CONVRTASCI      PROC    NEAR
;       Convert a signed, 1-byte number into an ascii character string
;       Assumes the number in AL with AH = 0
;       Assumes DI contains the address of the memory location to place
;       the converted digit (Should be initially set to the right-most
;       position).  Since DI is normally an index rather than an address
;       register we cannot use the size attribute with it.
;       The algorithm finds the right-most digit next.
;
        MOV     SIGN,0          ;First take care of the sign
        CMP     AL,0
        JGE     PROCESS_NUMB
        NEG     AL
        INC     SIGN
;
PROCESS_NUMB:
        MOV     BL,10
;
CONVRTLOOP1:
        DIV     BL              ;If numb <> 0 then divide by 10
;
;       The remainder is the next digit
;
        ADD     AH,'0'
        MOV     [DI],AH         ;Convert remainder and save it
;
        DEC     DI
        MOV     AH,0
;        
        CMP     AL,0
        JNE     CONVRTLOOP1
;
ADD_SIGN:
        CMP     SIGN,0
        JE      EXIT_DONE
;       
;       Here we are forced to get around the lack of size attribute 
;       on the DI register...
;
        MOV     AH,'-'
        MOV     [DI],AH
;
EXIT_DONE:
        RET
CONVRTASCI   ENDP
; ******************** List algorithms ***********************
; 1. Copy A list
;
COPYLIST  PROC    NEAR
;  we assume that the si and di are set
          MOV   AX,DS
          MOV   ES,AX
          CLD
          REP   MOVSB
          RET
COPYLIST  ENDP
;

; 2.  PRINT A LIST
;
PRINTLIST PROC	NEAR
; subprogram to print out a list of numbers
; using all global data area
; only parameter is a flag in al that tells 
; which heading to print
        LEA     DX,CRLF
        CALL    STROUT
;  use same area to print list - AL == 0 print unsorted
;  heading else use sorted heading
        CMP     AL,1
        JE      SORT_HEAD
        LEA     DX,HEAD1
        CALL    STROUT
        JMP     PRNT_NUMBERS
SORT_HEAD:
        LEA     DX,SRTLNE
        CALL    STROUT
PRNT_NUMBERS:
;
;               LOOP TO PRINT THE LIST OF NUMBERS
;
        MOV     SI,0             ;LOOP CONTROLS - SUBSCRIPT FOR NUMBS
        MOV     CH,0
        MOV     CL,N
;               
;
NEXT_NUMB:
        JCXZ    PRINTOVER
        LEA     DI,NUMBLNE+19   ;LOCATION FOR RIGHT-MOST DIGIT
        MOV     AH,0
        PUSH    BX
        MOV     AL,[BX+SI]
        CALL    CONVRTASCI
        LEA     DX,NUMBLNE
        CALL    STROUT
        POP     BX
        INC     SI
        MOV     WORD PTR NUMBLNE+18,2020H  ;These are bytes ==> to get 2-byte
        MOV     WORD PTR NUMBLNE+16,2020H  ;move must say WORD PTR
        DEC     CX
        JMP     NEXT_NUMB

PRINTOVER:
        RET
PRINTLIST ENDP
;
; ------------------------ SORTING ALGORITHMS ------------------------
; 3. SORT A LIST
; 
EXCHANGESORT  PROC   NEAR
; simple exchange sort -
;   sort the numbers and then print them
;  void exchangeSort (int A[], int n)
;  { for (int j = 0; j < n-1; j++)
;     for (int k = j+1; k < n; k++)
;       if (A[j] > A[k})
;       { // swap - generally we will just write swap here
;         int temp = A[j];
;            A[j] = A[k];
;            A[k] = temp;
;       }
;    return;
;  }
        MOV    CH,DL
        DEC    CH
        MOV    SI,0
JLOOP:  CMP    CH,0
        JE     SORTDONE
;   start the k loop - note that the subscript is separate from the
;   the loop control - ch and cl tell us how many times to loop
        MOV    CL,CH
        MOV    DI,SI
        INC    DI             ;k = j+1
KLOOP:  CMP    CL,0
        JE     K_LOOP_DONE
        MOV    AL,[BX+SI]
        CMP    AL,[BX+DI]
        JLE    NEXTK
        MOV    AH,[BX+DI]
        MOV    [BX+DI],AL
        MOV    [BX+SI],AH
NEXTK:  INC    DI
        DEC    CL
        JMP    KLOOP
K_LOOP_DONE:
        INC    SI
        DEC    CH
        JMP    JLOOP
;
SORTDONE:
        RET
EXCHANGESORT  ENDP
;
;   BUBBLE SORT
;
BUBBLESORT  PROC   NEAR
; classic bubble sort -
; void bubbleSort (int A[], int n)
; { int exchanges, end = n-1;
;   do
;   {  exchanges = 0;
;      for (int i = 0; i < end; i++)
;        if (A[i] > A[i+1])
;        { int temp = A[i];
;          A[i] = A[i+1];
;          A[i+1] = temp;
;          exchanges++;
;        }
;   } while (exchanges > 0);
; }
; register usage:
;   DH = number of exchanges done
;   DL = number of loop iterations
;   
DO_LOOP_TOP:
        MOV   SI,0  ;i
        MOV   DI,0  ; i+1
        INC   DI
        MOV   DH,0  ; exchanges
        DEC   DL    ; n
FOR_LOOP:
        MOV   CH,0
        MOV   CL,DL
FOR_LOOP_TOP:
        JCXZ  FOR_LOOP_DONE
        MOV    AL,[BX+SI]
        CMP    AL,[BX+DI]
        JLE    NEXTI
        MOV    AH,[BX+DI]
        MOV    [BX+DI],AL
        MOV    [BX+SI],AH
        INC    DH         ; exchanges++
NEXTI:
        INC    SI
        INC    DI
        DEC    CX
        JMP    FOR_LOOP_TOP
FOR_LOOP_DONE:
        CMP   DH,0
        JG    DO_LOOP_TOP
        RET
BUBBLESORT ENDP
;
;  Simple insertion sort
;
INSERTIONSORT  PROC  NEAR
;  void insertionSort (int A[], int n)
;  { for (int i = 1; i < n; i++)  
;    { int temp = A[i];       // pull out to create empty slot
;          // slide items over
;      int j = i-1;
;      while (j>=0) && (temp < A[j]))
;          A[j+1] = a[j];
;         // put item back in list  
;      A[j+1] = temp;
;    }
;  } 
        MOV    CH,0
        MOV    CL,DL
        MOV    SI,1
I_FOR_LOOP_TOP:
        MOV    DH,[BX+SI]    ;DH is temp
        MOV    DI,SI
;  here we can use DI as j and actually do not need to count
;  using the CX register as is typically the case
        DEC    DI            ;j=i-1
WHILE_LOOP_TOP:
        CMP    DH,[BX+DI]     ;compare temp with A[j]
        JGE    WHILE_LOOP_DONE
;   move A[j+1] = A[j]
        MOV    AL,[BX+DI]
        MOV    [BX+DI+1],AL   ;A[j+1] = A[j]
        DEC    DI
        CMP    DI,0
        JGE    WHILE_LOOP_TOP
WHILE_LOOP_DONE:
        MOV    [BX+DI+1],DH
        INC    SI
        DEC    CX
        CMP    CX,1
        JNE    I_FOR_LOOP_TOP
        RET
INSERTIONSORT  ENDP
;
QUICKSORT  PROC
; recursive subprogram
; void quickSort (int A[], int Left, int Right); 
; { int i,j;
;   int pivot;
;   if (Left < Right)
;   { i = Left;
;     j = Right+1;
;     pivot = L[Left];
;     do
;     { do
;        i++;
;       while ((i < j) && (A[i] < pivot));
;       do
;         j--;
;       while (A[j] > pivot);
;       if ( i < j)
;         swap (A[i],A[j]);
;     }while (i < j);
;     swap (A[left],A[j]);    // put pivot back in array
;     quickSort (A,Left,j-1);
;     quickSort (A,j+1,Right);
;   }
; }
; For this one we build activation records on the stack
; leave the address of A in BX => Left and Right become
; the stack parameters
;   SI == i
;   DI == j
        PUSH   BP
        MOV    BP,SP
        MOV    DI,[BP+4] ;right
        MOV    SI,[BP+6] ;left
IF_STMT:
        CMP    SI,DI
        JGE    DONE
        MOV    AL,[BX+SI] ;pivot == al
        INC    DI
;   start the primary do loop here
;   also start the "do i++ while. . . "  loop
I_DO_LOOP:
        INC    SI
        CMP    AL,[BX+SI]
        JL     J_DO_LOOP
        INC    SI
        CMP    SI,DI
        JL     I_DO_LOOP
;   here is the "do j-- while . . " loop
J_DO_LOOP:
        DEC    DI
        CMP    AL,[BX+DI]
        JGE    J_FOUND
        JMP    J_DO_LOOP
;   end of the main do wile loop
J_FOUND:
        CMP    SI,DI
        JGE    LOOP_DONE
; swap A[i] and A[j]
        MOV    DH,[BX+SI]
        MOV    DL,[BX+DI]
        MOV    [BX+DI],DH
        MOV    [BX+SI],DL
        JMP    I_DO_LOOP
LOOP_DONE:
;  swap A[left] and A[j]
        MOV    AH,[BX+DI]   ; get A[j]
        MOV    [BX+DI],AL   ; pivot == A[left] in al
;  because si moved need to get left back
        MOV    SI,[BP+6]
        MOV    [BX+SI],AH
; recursive calls
;    quickSort (A,Left,j-1)
;      save j for second recursive call
        PUSH   DI  
        PUSH   SI  ;left in SI from above
        DEC    DI  ; j - 1
        PUSH   DI
        CALL   QUICKSORT
; second recursive call
;   quickSort (A,j+1,Right)
        POP    DI   ; get j back
        INC    DI   ; j+1
        PUSH   DI
        MOV    AX,[BP+4] ; get Right from stack
        PUSH   AX
        CALL   QUICKSORT
;
DONE:
        POP   BP
        RET   4   ; remove left and right from the stack
QUICKSORT  ENDP
        END  
